#!/bin/sh

if [ ! "`pwd`" = "/" ]; then ## Woof build
	echo "Installing PupControl"
	mkdir -p ./usr/local/PupControl/defaultapps/
	mv -f ./tmp/PCONTROL-install/defaultapps/* ./usr/local/PupControl/defaultapps/
	mv -f ./tmp/PCONTROL-install/*.rc ./usr/local/PupControl/
	rm -rf ./tmp/PCONTROL-install/

	[ -f ./usr/sbin/wizardwizard ] && [ ! -f ./usr/sbin/wizardwizard.orig ] && cp -f ./usr/sbin/wizardwizard ./usr/sbin/wizardwizard.orig
	echo -e '#!/bin/bash\nexec PupControl' > ./usr/sbin/wizardwizard && chmod 755 ./usr/sbin/wizardwizard

else ##Conventional PET install

#---Fatdog64 non-support alert
	. /etc/DISTRO_SPECS
	if [ "$DISTRO_NAME" = "Fatdog64" ]; then
	 sed -i -e 's/.*DISTRO_SPECS.*/&\n[ "$DISTRO_NAME" = "Fatdog64" ] \&\& Xdialog --title Alert --beep --msgbox " PupControl does not support Fatdog64. " 0 0 \&\& exit 0 #FD64 has built-in control panel/' /usr/local/PupControl/PupControl-bin
	 Xdialog --title Alert --beep --msgbox " PupControl does not support Fatdog64. " 0 0 && exit 0
	fi

#---Provide option to link PupControl to wizardwizard (exclude non-standard wizardwizard)
	if [ "`grep -i 'wizard' /usr/sbin/wizardwizard`" ]; then
	  Xdialog --title "PupControl" --cancel-label "No" --ok-label "Yes"  --yesno " Link desktop setup (wizardwizard) to PupControl? " 0x0+200+100
	  if [[ $? == 0 ]]; then
	   [ ! -f /usr/sbin/wizardwizard.orig ] && cp -f /usr/sbin/wizardwizard /usr/sbin/wizardwizard.orig
	   echo -e '#!/bin/bash\nexec PupControl' > /usr/sbin/wizardwizard && chmod 755 /usr/sbin/wizardwizard
	  fi
	fi

#---set jwmdesk first-run autohide parameter to "off" in JWM vgit >=1026 and standard releases >= 2.3.0
	if [-d /usr/local/jwm_config ]; then
	 JWM_HOME="/root/.jwm"
	 jwmtray="jwmrc-tray1"
	else
	 JWM_HOME="/root"
	 jwmtray=".jwmrc-tray"
	fi

	JWM_VER=$(jwm -v | head -n1 | cut -d " " -f2- | cut -d " " -f1 | sed -e 's/[snvgit-]//g')
	if [ "`jwm -v | head -n1 | grep -E 'vgit|vsvn' 2>/dev/null`" ]; then
	 if ((`bc <<< "$JWM_VER>=1026"`)); then
	  sed -i -e 's#autohide="true"#autohide="off"#' -e 's#autohide="false"#autohide="off"#' $JWM_HOME/$jwmtray
	 fi
	elif [ "`echo "$JWM_VER" | grep -E '^2.3.[0-9]|^2.[4-9]|^[3-9]' 2>/dev/null`" ]; then
	  sed -i -e 's#autohide="true"#autohide="off"#' -e 's#autohide="false"#autohide="off"#' $JWM_HOME/$jwmtray
	fi

#---update gtkdialog path for treeicons
	/usr/local/jwmdesk/treeicons

#---create icon symlinks to support non-path treeicons in Slacko-6.3.0.X (likely not required for subsequent Slackos)
	if [[ $(echo $DISTRO_NAME | grep -i slacko) ]]; then
 	 if [[ $(echo $DISTRO_VERSION | grep '6\.3\.0') ]]; then
  	  ls /usr/share/pixmaps/puppy | sort > /tmp/tmp
   	   while read -r icon
    	    do
      	      [ ! -f /usr/share/pixmaps/"$icon" ] && ln -snf /usr/share/pixmaps/puppy/"$icon" /usr/share/pixmaps/
    	    done < /tmp/tmp
 	 fi
	fi

#---check default apps for categories and icons
	[ -f /usr/share/applications/defaultaudioplayer.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultaudioplayer.desktop`" ] && echo "Categories=Audio" >> /usr/share/applications/defaultaudioplayer.desktop
	[ -f /usr/share/applications/defaultbrowser.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultbrowser.desktop`" ] && echo "Categories=X-Internet-browser" >> /usr/share/applications/defaultbrowser.desktop
	[ -f /usr/share/applications/defaultchmviewer.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultchmviewer.desktop`" ] && echo "Categories=X-Document-viewer" >> /usr/share/applications/defaultchmviewer.desktop
	[ -f /usr/share/applications/defaultimageviewer.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultimageviewer.desktop`" ] && echo "Categories=Presentation" >> /usr/share/applications/defaultimageviewer.desktop
	[ -f /usr/share/applications/defaultmediaplayer.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultmediaplayer.desktop`" ] && echo "Categories=AudioVideo" >> /usr/share/applications/defaultmediaplayer.desktop
	[ -f /usr/share/applications/defaultpdfviewer.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultpdfviewer.desktop`" ] && echo "Categories=X-Document-viewer" >> /usr/share/applications/defaultpdfviewer.desktop
	[ -f /usr/share/applications/defaultspreadsheet.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultspreadsheet.desktop`" ] && echo "Categories=X-Business-spreadsheet" >> /usr/share/applications/defaultspreadsheet.desktop
	[ -f /usr/share/applications/defaulttexteditor.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaulttexteditor.desktop`" ] && echo "Categories=TextEditor" >> /usr/share/applications/defaulttexteditor.desktop
	[ -f /usr/share/applications/defaultwordprocessor.desktop ] && [ ! "`grep '^Categories' /usr/share/applications/defaultwordprocessor.desktop`" ] && echo "Categories=WordProcessor" >> /usr/share/applications/defaultwordprocessor.desktop

	[ -f /usr/share/applications/defaultaudioplayer.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultaudioplayer.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/multimedia48.png" >> /usr/share/applications/defaultaudioplayer.desktop
	[ -f /usr/share/applications/defaultbrowser.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultbrowser.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/www48.png" >> /usr/share/applications/defaultbrowser.desktop
	[ -f /usr/share/applications/defaultimageviewer.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultimageviewer.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/draw48.png" >> /usr/share/applications/defaultimageviewer.desktop
	[ -f /usr/share/applications/defaultmediaplayer.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultmediaplayer.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/multimedia48.png" >> /usr/share/applications/defaultmediaplayer.desktop
	[ -f /usr/share/applications/defaultpdfviewer.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultpdfviewer.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/folder48.png" >> /usr/share/applications/defaultpdfviewer.desktop
	[ -f /usr/share/applications/defaultspreadsheet.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultspreadsheet.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/spread48.png" >> /usr/share/applications/defaultspreadsheet.desktop
	[ -f /usr/share/applications/defaulttexteditor.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaulttexteditor.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/edit48.png" >> /usr/share/applications/defaulttexteditor.desktop
	[ -f /usr/share/applications/defaultwordprocessor.desktop ] && [ ! "`grep '^Icon' /usr/share/applications/defaultwordprocessor.desktop`" ] && echo "Icon=/usr/local/lib/X11/pixmaps/word48.png" >> /usr/share/applications/defaultwordprocessor.desktop

#---check missing images in icon themes
THEMES=`ls /usr/local/lib/X11/themes | sort`
for i in $THEMES 
  do
    if [ -d /usr/local/lib/X11/themes/$i ]; then
     if [ -f /usr/local/lib/X11/themes/$i/games24.png ] && [ ! -f /usr/local/lib/X11/themes/$i/games48.png ]; then
      cp -f /usr/local/lib/X11/themes/$i/games24.png /tmp/tmp
      mv -f /tmp/tmp /usr/local/lib/X11/themes/$i/games48.png
     fi
     if [ -f /usr/local/lib/X11/themes/$i/pc24.png ] && [ ! -f /usr/local/lib/X11/themes/$i/pc48.png ]; then
      cp -f /usr/local/lib/X11/themes/$i/pc24.png /tmp/tmp
      mv -f /tmp/tmp /usr/local/lib/X11/themes/$i/pc48.png
     fi
     if [ -f /usr/local/lib/X11/themes/$i/shutdown24.png ] && [ ! -f /usr/local/lib/X11/themes/$i/shutdown48.png ]; then
      cp -f /usr/local/lib/X11/themes/$i/shutdown24.png /tmp/tmp
      mv -f /tmp/tmp /usr/local/lib/X11/themes/$i/shutdown48.png
     fi
     if [ -f /usr/local/lib/X11/themes/$i/utility24.png ] && [ ! -f /usr/local/lib/X11/themes/$i/utility48.png ]; then
      cp -f /usr/local/lib/X11/themes/$i/utility24.png /tmp/tmp
      mv -f /tmp/tmp /usr/local/lib/X11/themes/$i/utility48.png
     fi
     if [ -f /usr/local/lib/X11/themes/$i/x24.png ] && [ ! -f /usr/local/lib/X11/themes/$i/x48.png ]; then
      cp -f /usr/local/lib/X11/themes/$i/x24.png /tmp/tmp
      mv -f /tmp/tmp /usr/local/lib/X11/themes/$i/x48.png
     fi
     if [ -f /usr/local/lib/X11/themes/$i/x.png ] && [ ! -f /usr/local/lib/X11/themes/$i/x48.png ]; then
      cp -f /usr/local/lib/X11/themes/$i/x.png /tmp/tmp
      mv -f /tmp/tmp /usr/local/lib/X11/themes/$i/x48.png
     fi
    fi
  done
  [ ! -f /usr/local/lib/X11/pixmaps/pc48.png ] && [ -f /usr/local/lib/X11/pixmaps/pc24.png ] && cp -f /usr/local/lib/X11/pixmaps/pc24.png /tmp/tmp && mv -f /tmp/tmp /usr/local/lib/X11/pixmaps/pc48.png

#---Requirements for BK's Quirky
	if [[ $(echo $DISTRO_NAME | grep -i quirky) ]]; then
	 sed -i 's/wallpaper/qwallpaper/' /usr/local/PupControl/defaultapps/wallpaper
	 sed -i 's/^.*WALLPAPER=.*$/WALLPAPER="qwallpaper"/' /usr/local/PupControl/pupcontrol.rc
	 sed -i 's/^.*WALLPAPER=.*$/WALLPAPER="qwallpaper"/' /usr/local/PupControl/pupcontrol2.rc
	 sed -i 's/^.*Icon=.*$/Icon=\/usr\/share\/mmarchitect\/icons\/mmarchitect_48.png/' /usr/share/applications/mmarchitect.desktop
	 sed -i 's/^.*Icon=.*$/Icon=\/usr\/share\/mmarchitect\/icons\/mmarchitect_48.png/' /usr/share/applications/mmarchitect-help.desktop
	 echo "510" > /usr/local/jwmdesk/windowwidth
	fi

#---If PupControl is already installed, do not overwrite current configuration files
	if [ -f /usr/local/PupControl/pupcontrol.rc ]; then
	 rm -rf /tmp/PCONTROL-install/
#	 Xdialog --title PupControl --beep --msgbox " All files are installed... \n\n Prior PupControl configuration settings are unchanged. " 0x0+200+100 && exit 0
	else
	 mkdir -p /usr/local/PupControl/defaultapps/
	 mv -f /tmp/PCONTROL-install/defaultapps/* /usr/local/PupControl/defaultapps/
	 mv -f /tmp/PCONTROL-install/*.rc /usr/local/PupControl/
	 rm -rf /tmp/PCONTROL-install/
#	 Xdialog --title PupControl --beep --msgbox " All files are installed... \n\n The PupControl 'Ctrl+Shift+C' hotkey is available for \n IceWM, JWM, Fluxbox, Openbox and LXDE-LXPanel.  \n\n Go to PupControl Preferences to select the \n default applications and program hotkey. " 0x0+200+100 && exit 0
	fi
fi

#END
